#byte puerto_a=0x05
#byte puerto_b=0x06
#byte TRISA=0x85
#byte TRISB=0x86
#byte TMR0=1
#byte OPTION_REG=0x81
#byte INTE=0x0B
#byte STATUS=3


#define Set_Datos puerto_b=puerto_b | 4
#define Clear_Datos puerto_b=puerto_b & 251

void SENDCADE(char *x);
void PrintStr(char *string);
void PrintAtNum(unsigned char x,int numero);
void PrintAtStr(unsigned char x,char *string);



//100->1ms    50000->500ms   Sobre reloj de 4mhz
void delay_seta(int16 dz)
{
   while(dz)
      {
         dz--;      
      }
}

void enable_seta(void)
{
   puerto_b=puerto_b | 8;
   delay_seta(200);
   puerto_b=puerto_b & 247;
   delay_seta(200);
}
void sendchar_seta(char x)
{
   //4 BYTES DE MAS PESO
   puerto_b=(puerto_b&15)|(x&240);
   enable_seta();
   #asm
      swapf x,1
   #endasm
   //4 BYTES DE MENOS PESO
   puerto_b=(puerto_b&15)|(x&240);
   enable_seta();
}
void sendi_seta(char x)
{
   Clear_Datos;
   sendchar_seta(x);
   delay_seta(200);
   Set_Datos;
   delay_seta(200);
}

void lcd_at_seta(int x)
{
   //0 Comienzo lnea1, 64 Comienzo lnea2
   x=x | 128;
   sendi_seta(x);
}

/*
void lcd_home(void)
{
   sendi_seta(2);
}
*/
void lcd_cls(void)
{
   sendi_seta(1);
}
/*void lcd_ini(void)
{
   delay_seta(25000);

}
*/
void Pon4bits(char x)
{
 char z;
 z=puerto_b & 0x0f;
 #asm
      swapf x,1
 #endasm
 x= x & 0xf0;
 puerto_b= x |z;
}

void lcd_ini_seta(void)
{
   //delay_ms(250);
   delay_seta(25000);
   Pon4bits(0x03);
   Clear_Datos;
   enable_seta();
   Set_Datos;
   //delay_ms(30);
   delay_seta(5000);
   Pon4bits(0x03);
   Clear_Datos;
   enable_seta();
   Set_Datos;
   //delay_ms(30);
   delay_seta(5000);
   Pon4bits(0x03);
   Clear_Datos;
   enable_seta();
   Set_Datos;
   //delay_ms(30);
   delay_seta(5000);

   Pon4bits(0x02); // modo 4 bits
   Clear_Datos;
   enable_seta();
   Set_Datos;
      
   sendi_seta(0x2c); //modo 4 bits, dos lineas
   sendi_seta(0x0f); // cursor con parpadeo
   sendi_seta(0x04);   
   
}

void lcd_gotoxy( BYTE x, BYTE y)
 {
   BYTE address;
   if(y!=1)
      {
      address=64+x;
      }
   else
      {
     address=x-1;
      }
   lcd_at_seta(address);   
}

//                            lcd_putc( char c)
//                              \f  Clear display                             
//                              \n  Go to start of second line                
//                              \b  Move back one position
void lcd_putc( char c) {
   switch (c) {
     case '\f'   : sendi_seta(1);
                   delay_ms(10);
                                           break;
     case '\n'   : lcd_gotoxy(1,2);        break;
     case '\b'   : sendi_seta(0x10);      break;
     default     : sendchar_seta(c);     break;
   }
}
